/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

Node *trans_pass (node)
Node *node;
{
    int i, type;
    PtFrN fun;
    Node *child;

    if (node == NN)
        return node;

#ifdef CHECK
	NODE_trans (node) = 1;
#endif

    type = node->com.type;

    if ((fun = function [PASS_TRANS] [0] [type]) != (PtFrN) 0)
        node = (*fun) (node);

    for (i = 0; i < node_nodes (type); i++)
        if ((child = node->com.node [i]) != (Node*) 0)
            node->com.node [i] = trans_pass (child);

    if ((fun = function [PASS_TRANS] [1] [type]) != (PtFrN) 0)
        node = (*fun) (node);

    return node;
}

Trans *trans_add_stmt_bef (trans, stmt)
Trans *trans;
Node *stmt;
{
	return trans_add_sta_bef (trans, make_Statement (NN, stmt));
}

Trans *trans_add_stmt_aft (trans, stmt)
Trans *trans;
Node *stmt;
{
	return trans_add_sta_aft (trans, make_Statement (NN, stmt));
}

Trans *trans_add_stmt_aft_before_last (trans, stmt)
Trans *trans;
Node *stmt;
{
	return trans_add_sta_aft_before_last (trans, make_Statement (NN, stmt));
}

Trans *trans_add_sta_bef (trans, sta)
Trans *trans;
Node *sta;
{
	Node **sta_bef;
	int i;

	if (trans == TRN)
		trans = trans_malloc ();

	if (trans->nbef || trans->sta_bef == (Node**) 0) {
		sta_bef = (Node**) U_malloc (sizeof (Node*) * (trans->nbef + 1));

		for (i = 0; i < trans->nbef; i++)
			sta_bef [i] = trans->sta_bef [i];

		U_free (trans->sta_bef);
		trans->sta_bef = sta_bef;
	}

	trans->sta_bef [trans->nbef++] = sta;

	return trans;
}

Trans *trans_add_sta_aft (trans, sta)
Trans *trans;
Node *sta;
{
	Node **sta_aft;
	int i;

	if (trans == TRN)
		trans = trans_malloc ();

	if (trans->naft || trans->sta_aft == (Node**) 0) {
		sta_aft = (Node**) U_malloc (sizeof (Node*) * (trans->naft + 1));

		for (i = 0; i < trans->naft; i++)
			sta_aft [i] = trans->sta_aft [i];

		U_free (trans->sta_aft);
		trans->sta_aft = sta_aft;
	}

	trans->sta_aft [trans->naft++] = sta;

	return trans;
}

Trans *trans_add_sta_aft_before_last (trans, sta)
Trans *trans;
Node *sta;
{
	Node **sta_aft, *last;
	int i;

	if (trans == TRN)
		trans = trans_malloc ();

	if (trans->naft || trans->sta_aft == (Node**) 0) {
		sta_aft = (Node**) U_malloc (sizeof (Node*) * (trans->naft + 1));

		for (i = 0; i < trans->naft - 1; i++)
			sta_aft [i] = trans->sta_aft [i];

		if (trans->naft)
			last = trans->sta_aft [trans->naft - 1];

		U_free (trans->sta_aft);
		trans->sta_aft = sta_aft;
	}

	if (trans->naft) {
		trans->sta_aft [trans->naft - 1] = sta;
		trans->sta_aft [trans->naft++] = last;
	}
	else
		trans->sta_aft [trans->naft++] = sta;

	return trans;
}

Trans *trans_malloc ()
{
	return (Trans*) U_malloc (sizeof (Trans));
}

int trans_tree_has_stmts (node)
Node *node;
{
	int i;

	if (node == NN)
		return 0;

	if (node->com.trans != TRN)
		return 1;
	else
		for (i = 0; i < node_nodes (node->com.type); i++)
			if (trans_tree_has_stmts (node->com.node [i]))
				return 1;

	return 0;
}
